package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/* PROTECTED REGION ID(ISLPoint_userImport) ENABLED START */
/* PROTECTED REGION END */

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLPoint extends JNIObject  {
	
	/* @generated */
	protected ISLPoint(long ptr) {
		/*** PROTECTED REGION ID(ISLPoint_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLPoint build(long ptr) {
		return new ISLPoint(ptr);
	}
	
	/* PROTECTED REGION ID(ISLPoint_userCode) ENABLED START */
	public int getNbDims() {
		return (int) this.getSpace().dim(ISLDimType.isl_dim_all);
	}

	/**
	 * Return a list of integer containing values of each component of the
	 * vector (i.e. value of the iterator for each dimension), including
	 * parameters dimensions (firsts in the list);
	 * 
	 * @return
	 */
	public List<Long> getCoordinates() {
		int n = getNbDims();
		List<Long> res = new ArrayList<>(n);
		for (int i = 0; i < n; i++) {
			res.add(getCoordinateVal(ISLDimType.isl_dim_all, i).asLong());
		}
		return res;
	}
	/* PROTECTED REGION END */

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_point_zero 
	 * 
	@take dim
	 * @generated
	**/
	 public static ISLPoint buildZero(ISLSpace dim) { 
		/*** PROTECTED REGION ID(static_isl_point_zero) DISABLED START ***/
		ISLPoint res;
		
		synchronized(LOCK) {
			checkParameters(dim);
			try {
				res = ISLPoint.build(ISLNative.isl_point_zero(getNativePtr(dim)));
			} finally {
				taken(dim);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_point_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_point_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_point_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_point_get_space 
	 * 
	 * @generated
	**/
	public ISLSpace getSpace() {
		/*** PROTECTED REGION ID(isl_point_get_space) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLSpace.build(ISLNative.isl_point_get_space(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_point_copy 
	 * 
	 * @generated
	**/
	public ISLPoint copy() {
		/*** PROTECTED REGION ID(isl_point_copy) DISABLED START ***/
		ISLPoint res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLPoint.build(ISLNative.isl_point_copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_point_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_point_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_point_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_from_point 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicSet toBasicSet() {
		/*** PROTECTED REGION ID(isl_basic_set_from_point) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicSet.build(ISLNative.isl_basic_set_from_point(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_from_point 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet toSet() {
		/*** PROTECTED REGION ID(isl_set_from_point) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.isl_set_from_point(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_from_point 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionSet toUnionSet() {
		/*** PROTECTED REGION ID(isl_union_set_from_point) DISABLED START ***/
		ISLUnionSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionSet.build(ISLNative.isl_union_set_from_point(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_point_get_coordinate_val 
	 * 
	 * @generated
	**/
	public ISLVal getCoordinateVal(ISLDimType type, int pos) {
		/*** PROTECTED REGION ID(isl_point_get_coordinate_val) DISABLED START ***/
		ISLVal res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLVal.build(ISLNative.isl_point_get_coordinate_val(getNativePtr(this), type.getValue(), pos));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_point_set_coordinate_val 
	 * 
	 * @take this v
	 * @generated
	**/
	public ISLPoint setCoordinate(ISLDimType type, int pos, ISLVal v) {
		/*** PROTECTED REGION ID(isl_point_set_coordinate_val) DISABLED START ***/
		ISLPoint res;
		
		synchronized(LOCK) {
			checkParameters(this, v);
			try {
				res = ISLPoint.build(ISLNative.isl_point_set_coordinate_val(getNativePtr(this), type.getValue(), pos, getNativePtr(v)));
			} finally {
				taken(this);
				taken(v);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_point_add_ui 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLPoint add(ISLDimType type, int pos, int val) {
		/*** PROTECTED REGION ID(isl_point_add_ui) DISABLED START ***/
		ISLPoint res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLPoint.build(ISLNative.isl_point_add_ui(getNativePtr(this), type.getValue(), pos, val));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_point_sub_ui 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLPoint sub(ISLDimType type, int pos, int val) {
		/*** PROTECTED REGION ID(isl_point_sub_ui) DISABLED START ***/
		ISLPoint res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLPoint.build(ISLNative.isl_point_sub_ui(getNativePtr(this), type.getValue(), pos, val));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLPoint_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
